<?php

Yii::import('application.modules.core_models.models._base.BasePasswordModel');

/**
 * This is the model base class for the table "patient".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Patient".
 *
 * Columns in table "patient" available as properties of the model,
 * followed by relations of table "patient" available as properties of the model.
 *
 * @property integer $id
 * @property integer $localization_id
 * @property integer $enabled
 * @property integer $super_admin
 * @property string $lang_id
 * @property string $email
 * @property string $secret
 * @property integer $partner_site_id
 * @property integer $account_device_id
 * @property integer $location_id
 * @property string $zipcode
 * @property string $age
 * @property string $gender
 * @property string $first_name
 * @property string $last_name
 * @property string $date_added
 * @property string $date_updated
 * @property string $last_password_change
 * @property string $date_signed_in
 * @property integer $pregnant
 * @property integer $insurance_id
 * @property string $address
 * @property string $address_2
 * @property string $day_phone
 * @property string $night_phone
 * @property string $mobile_phone
 * @property string $fax_phone
 * @property string $emergency_first_name
 * @property string $emergency_last_name
 * @property string $emergency_phone
 * @property string $emergency_relationship
 * @property string $date_of_birth
 * @property string $ethnicity
 * @property string $race
 * @property string $employment_status
 * @property string $ocupation
 * @property integer $employer_id
 * @property integer $receive_information
 *
 * @property Localization $localization
 * @property Insurance $insurance
 * @property Location $location
 * @property PracticePatient[] $practicePatients
 * @property ProviderPatient[] $providerPatients
 * @property ProviderRating[] $providerRatings
 * @property ReviewRequest[] $reviewRequests
 * @property SchedulingMail[] $schedulingMails
 */
abstract class BasePatient extends BasePasswordModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'patient';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Patient|Patients', $n);
    }

    public static function representingColumn()
    {
        return 'lang_id';
    }

    public function rules()
    {
        return array(
            array('email, date_updated, date_signed_in', 'required'),
            array('localization_id, receive_information, enabled, super_admin, partner_site_id, account_device_id, '
                . 'location_id, pregnant, insurance_id, employer_id', 'numerical', 'integerOnly' => true),
            array('lang_id', 'length', 'max' => 6),
            array('email', 'length', 'max' => 254),
            array('secret', 'length', 'max' => 60),
            array('zipcode, age', 'length', 'max' => 10),
            array('gender, receive_information', 'length', 'max' => 1),
            array('first_name', 'length', 'max' => 50),
            array('last_name, address, address_2, emergency_first_name, emergency_last_name', 'length', 'max' => 80),
            array('day_phone, night_phone, mobile_phone, fax_phone, emergency_phone', 'length', 'max' => 45),
            array('emergency_relationship', 'length', 'max' => 100),
            array('ethnicity, employment_status', 'length', 'max' => 2),
            array('race', 'length', 'max' => 4),
            array('ocupation', 'length', 'max' => 255),
            array('date_added, date_of_birth, last_password_change', 'safe'),
            array('localization_id, receive_information, enabled, super_admin, lang_id, partner_site_id, '
                . 'account_device_id, location_id, zipcode, age, gender, first_name, last_name, date_added, '
                . 'pregnant, insurance_id, address, address_2, day_phone, night_phone, mobile_phone, fax_phone, '
                . 'emergency_first_name, emergency_last_name, emergency_phone, emergency_relationship, date_of_birth, '
                . 'ethnicity, race, employment_status, ocupation, employer_id, receive_information', 'default',
                'setOnEmpty' => true, 'value' => null),
            array('id, localization_id, enabled, super_admin, lang_id, email, partner_site_id, account_device_id, '
                . 'location_id, zipcode, age, gender, first_name, last_name, date_added, date_updated, '
                . 'last_password_change, date_signed_in, pregnant, insurance_id, address, address_2, day_phone, '
                . 'night_phone, mobile_phone, fax_phone, emergency_first_name, emergency_last_name, emergency_phone, '
                . 'emergency_relationship, date_of_birth, ethnicity, race, employment_status, ocupation, employer_id',
                'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'localization' => array(self::BELONGS_TO, 'Localization', 'localization_id'),
            'insurance' => array(self::BELONGS_TO, 'Insurance', 'insurance_id'),
            'location' => array(self::BELONGS_TO, 'Location', 'location_id'),
            'practicePatients' => array(self::HAS_MANY, 'PracticePatient', 'patient_id'),
            'providerPatients' => array(self::HAS_MANY, 'ProviderPatient', 'patient_id'),
            'providerRatings' => array(self::HAS_MANY, 'ProviderRating', 'patient_id'),
            'reviewRequests' => array(self::HAS_MANY, 'ReviewRequest', 'patient_id'),
            'schedulingMails' => array(self::HAS_MANY, 'SchedulingMail', 'patient_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'localization_id' => null,
            'enabled' => Yii::t('app', 'Enabled'),
            'super_admin' => Yii::t('app', 'Super Admin'),
            'lang_id' => Yii::t('app', 'Lang'),
            'email' => Yii::t('app', 'Email'),
            'secret' => 'Secret',
            'password_confirm' => Yii::t('app', 'Confirm Password'),
            'partner_site_id' => Yii::t('app', 'Partner Site'),
            'account_device_id' => Yii::t('app', 'Account Device'),
            'location_id' => null,
            'zipcode' => Yii::t('app', 'Zipcode'),
            'age' => Yii::t('app', 'Age'),
            'gender' => Yii::t('app', 'Gender'),
            'first_name' => Yii::t('app', 'First Name'),
            'last_name' => Yii::t('app', 'Last Name'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'last_password_change' => Yii::t('app', 'Last Password Change'),
            'date_signed_in' => Yii::t('app', 'Date Signed In'),
            'pregnant' => Yii::t('app', 'Pregnant'),
            'insurance_id' => null,
            'address' => Yii::t('app', 'Address'),
            'address_2' => Yii::t('app', 'Address 2'),
            'day_phone' => Yii::t('app', 'Day Phone'),
            'night_phone' => Yii::t('app', 'Night Phone'),
            'mobile_phone' => Yii::t('app', 'Mobile Phone'),
            'fax_phone' => Yii::t('app', 'Fax Phone'),
            'emergency_first_name' => Yii::t('app', 'Emergency First Name'),
            'emergency_last_name' => Yii::t('app', 'Emergency Last Name'),
            'emergency_phone' => Yii::t('app', 'Emergency Phone'),
            'emergency_relationship' => Yii::t('app', 'Emergency Relationship'),
            'date_of_birth' => Yii::t('app', 'Date Of Birth'),
            'ethnicity' => Yii::t('app', 'Ethnicity'),
            'race' => Yii::t('app', 'Race'),
            'employment_status' => Yii::t('app', 'Employment Status'),
            'ocupation' => Yii::t('app', 'Ocupation'),
            'employer_id' => Yii::t('app', 'Employer'),
            'receive_information' => Yii::t('app', 'Receive Information'),
            'localization' => null,
            'insurance' => null,
            'location' => null,
            'practicePatients' => null,
            'providerPatients' => null,
            'providerRatings' => null,
            'reviewRequests' => null,
            'schedulingMails' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('localization_id', $this->localization_id);
        $criteria->compare('enabled', $this->enabled);
        $criteria->compare('super_admin', $this->super_admin);
        $criteria->compare('lang_id', $this->lang_id, true);
        $criteria->compare('email', $this->email, true);
        $criteria->compare('secret', $this->secret, true);
        $criteria->compare('partner_site_id', $this->partner_site_id);
        $criteria->compare('account_device_id', $this->account_device_id);
        $criteria->compare('location_id', $this->location_id);
        $criteria->compare('zipcode', $this->zipcode, true);
        $criteria->compare('age', $this->age, true);
        $criteria->compare('gender', $this->gender, true);
        $criteria->compare('first_name', $this->first_name, true);
        $criteria->compare('last_name', $this->last_name, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('last_password_change', $this->last_password_change, true);
        $criteria->compare('date_signed_in', $this->date_signed_in, true);
        $criteria->compare('pregnant', $this->pregnant);
        $criteria->compare('insurance_id', $this->insurance_id);
        $criteria->compare('address', $this->address, true);
        $criteria->compare('address_2', $this->address_2, true);
        $criteria->compare('day_phone', $this->day_phone, true);
        $criteria->compare('night_phone', $this->night_phone, true);
        $criteria->compare('mobile_phone', $this->mobile_phone, true);
        $criteria->compare('fax_phone', $this->fax_phone, true);
        $criteria->compare('emergency_first_name', $this->emergency_first_name, true);
        $criteria->compare('emergency_last_name', $this->emergency_last_name, true);
        $criteria->compare('emergency_phone', $this->emergency_phone, true);
        $criteria->compare('emergency_relationship', $this->emergency_relationship, true);
        $criteria->compare('date_of_birth', $this->date_of_birth, true);
        $criteria->compare('ethnicity', $this->ethnicity, true);
        $criteria->compare('race', $this->race, true);
        $criteria->compare('employment_status', $this->employment_status, true);
        $criteria->compare('ocupation', $this->ocupation, true);
        $criteria->compare('employer_id', $this->employer_id);
        $criteria->compare('receive_information', $this->receive_information, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
